public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Mike Frysinger" <vapier@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: app-arch/tar/, app-arch/tar/files/
Date: Tue, 17 Jan 2017 20:43:36 +0000 (UTC)	[thread overview]
Message-ID: <1484685764.0be4e2ac7ec0906aff61da2a1a749ebd17db746c.vapier@gentoo> (raw)

commit:     0be4e2ac7ec0906aff61da2a1a749ebd17db746c
Author:     Mike Frysinger <vapier <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 17 20:42:44 2017 +0000
Commit:     Mike Frysinger <vapier <AT> gentoo <DOT> org>
CommitDate: Tue Jan 17 20:42:44 2017 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=0be4e2ac

app-arch/tar: pull in upstream fix for --add-file behvaior

 app-arch/tar/files/tar-1.29-add-files.patch | 194 ++++++++++++++++++++++++++++
 app-arch/tar/tar-1.29-r3.ebuild             |  81 ++++++++++++
 2 files changed, 275 insertions(+)

diff --git a/app-arch/tar/files/tar-1.29-add-files.patch b/app-arch/tar/files/tar-1.29-add-files.patch
new file mode 100644
index 00000000..8ab15ac
--- /dev/null
+++ b/app-arch/tar/files/tar-1.29-add-files.patch
@@ -0,0 +1,194 @@
+From 3a283cfe9f8f1f127e8dc5597a5ea1d249985a54 Mon Sep 17 00:00:00 2001
+From: Sergey Poznyakoff <gray@gnu.org>
+Date: Sat, 12 Nov 2016 11:20:47 +0200
+Subject: [PATCH] Fix the --add-file option.
+
+* src/common.h (name_more_files): New proto.
+(files_from_option): Remove.
+* src/names.c (name_more_files): New file.
+(names_options): Fix declaration of the
+add-file option.
+(names_parse_opt): Handle --add-file.
+* src/tar.c (struct tar_args): Remove the input_files member.
+Change all uses: use name_more_files() instead.
+* tests/Makefile.am: Add new test.
+* tests/add-file.at: New testcase.
+* tests/testsuite.at: Add new test.
+---
+ src/common.h       |  4 +---
+ src/names.c        | 24 ++++++++++++-------
+ src/tar.c          | 16 ++++---------
+ tests/Makefile.am  |  3 ++-
+ tests/add-file.at  | 67 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
+ tests/testsuite.at |  1 +
+ 6 files changed, 92 insertions(+), 23 deletions(-)
+ create mode 100644 tests/add-file.at
+
+diff --git a/src/common.h b/src/common.h
+index 50c34cc7c09b..6fdb6225f18b 100644
+--- a/src/common.h
++++ b/src/common.h
+@@ -414,9 +414,6 @@ GLOBAL bool show_transformed_names_option;
+    timestamps from archives with an unusual member order. It is automatically
+    set for incremental archives. */
+ GLOBAL bool delay_directory_restore_option;
+-
+-/* When set, tar will not refuse to create empty archives */
+-GLOBAL bool files_from_option;
+ \f
+ /* Declarations for each module.  */
+ 
+@@ -738,6 +735,7 @@ void uid_to_uname (uid_t uid, char **uname);
+ int uname_to_uid (char const *uname, uid_t *puid);
+ 
+ void name_init (void);
++bool name_more_files (void);
+ void name_add_name (const char *name);
+ void name_term (void);
+ const char *name_next (int change_dirs);
+diff --git a/src/names.c b/src/names.c
+index 219aa77a4356..1a9465667cd3 100644
+--- a/src/names.c
++++ b/src/names.c
+@@ -32,7 +32,8 @@ static void name_add_file (const char *name);
+ \f
+ enum
+   {
+-    EXCLUDE_BACKUPS_OPTION = 256,
++    ADD_FILE_OPTION = 256,
++    EXCLUDE_BACKUPS_OPTION,
+     EXCLUDE_CACHES_OPTION,
+     EXCLUDE_CACHES_UNDER_OPTION,
+     EXCLUDE_CACHES_ALL_OPTION,
+@@ -67,7 +68,7 @@ static struct argp_option names_options[] = {
+   {NULL, 0, NULL, 0,
+    N_("Local file name selection:"), GRID },
+ 
+-  {"add-file", ARGP_KEY_ARG, N_("FILE"), 0,
++  {"add-file", ADD_FILE_OPTION, N_("FILE"), 0,
+    N_("add given FILE to the archive (useful if its name starts with a dash)"), GRID+1 },
+   {"directory", 'C', N_("DIR"), 0,
+    N_("change to directory DIR"), GRID+1 },
+@@ -190,10 +191,10 @@ names_parse_opt (int key, char *arg, struct argp_state *state)
+ 
+     case 'T':
+       name_add_file (arg);
+-      /* Indicate we've been given -T option. This is for backward
+-	 compatibility only, so that `tar cfT archive /dev/null will
+-	 succeed */
+-      files_from_option = true;
++      break;
++
++    case ADD_FILE_OPTION:
++      name_add_name (arg);
+       break;
+ 
+     default:
+@@ -651,8 +652,8 @@ struct name_elt        /* A name_array element. */
+   } v;
+ };
+ 
+-static struct name_elt *name_head;  /* store a list of names */
+-size_t name_count;	 	    /* how many of the entries are names? */
++static struct name_elt *name_head;/* store a list of names */
++size_t name_count;	 	  /* how many of the entries are file names? */
+ 
+ static struct name_elt *
+ name_elt_alloc (void)
+@@ -784,6 +785,12 @@ name_list_advance (void)
+     }
+ }
+ 
++/* Return true if there are names or options in the list */
++bool
++name_more_files (void)
++{
++  return name_count > 0;
++}
+ 
+ /* Add to name_array the file NAME with fnmatch options MATFLAGS */
+ void
+@@ -823,6 +830,7 @@ name_add_file (const char *name)
+   ep->v.file.name = name;
+   ep->v.file.line = 0;
+   ep->v.file.fp = NULL;
++  name_count++;
+ }
+ \f
+ /* Names from external name file.  */
+diff --git a/src/tar.c b/src/tar.c
+index 35bac38c2793..a361fc2c607f 100644
+--- a/src/tar.c
++++ b/src/tar.c
+@@ -813,7 +813,6 @@ struct tar_args        /* Variables used during option parsing */
+   bool pax_option;                 /* True if --pax-option was given */
+   char const *backup_suffix_string;   /* --suffix option argument */
+   char const *version_control_string; /* --backup option argument */
+-  bool input_files;                /* True if some input files where given */
+   int compress_autodetect;         /* True if compression autodetection should
+ 				      be attempted when creating archives */
+ };
+@@ -1322,7 +1321,6 @@ parse_opt (int key, char *arg, struct argp_state *state)
+     case ARGP_KEY_ARG:
+       /* File name or non-parsed option, because of ARGP_IN_ORDER */
+       name_add_name (arg);
+-      args->input_files = true;
+       break;
+ 
+     case 'A':
+@@ -2179,7 +2177,7 @@ more_options (int argc, char **argv, struct option_locus *loc)
+   args.loc = loc;
+   if (argp_parse (&argp, argc, argv, ARGP_IN_ORDER|ARGP_NO_EXIT, &idx, &args))
+     abort (); /* shouldn't happen */
+-  if (loc->source == OPTS_ENVIRON && args.input_files)
++  if (loc->source == OPTS_ENVIRON && name_more_files ())
+     USAGE_ERROR ((0, 0, _("non-option arguments in %s"), loc->name));
+ }
+ 
+@@ -2221,7 +2219,6 @@ decode_options (int argc, char **argv)
+   args.pax_option = false;
+   args.backup_suffix_string = getenv ("SIMPLE_BACKUP_SUFFIX");
+   args.version_control_string = 0;
+-  args.input_files = false;
+   args.compress_autodetect = false;
+ 
+   subcommand_option = UNKNOWN_SUBCOMMAND;
+@@ -2340,10 +2337,7 @@ decode_options (int argc, char **argv)
+ 
+   /* Handle operands after any "--" argument.  */
+   for (; idx < argc; idx++)
+-    {
+-      name_add_name (argv[idx]);
+-      args.input_files = true;
+-    }
++    name_add_name (argv[idx]);
+ 
+   /* Derive option values and check option consistency.  */
+ 
+@@ -2365,7 +2359,7 @@ decode_options (int argc, char **argv)
+ 
+   if (occurrence_option)
+     {
+-      if (!args.input_files)
++      if (!name_more_files ())
+ 	USAGE_ERROR ((0, 0,
+ 		      _("--occurrence is meaningless without a file list")));
+       if (!IS_SUBCOMMAND_CLASS (SUBCL_OCCUR))
+@@ -2569,7 +2563,7 @@ decode_options (int argc, char **argv)
+     {
+       /* --test-label is silent if the user has specified the label name to
+ 	 compare against. */
+-      if (!args.input_files)
++      if (!name_more_files ())
+ 	verbose_option++;
+     }
+   else if (utc_option)
+@@ -2598,7 +2592,7 @@ decode_options (int argc, char **argv)
+   switch (subcommand_option)
+     {
+     case CREATE_SUBCOMMAND:
+-      if (!args.input_files && !files_from_option)
++      if (!name_more_files ())
+ 	USAGE_ERROR ((0, 0,
+ 		      _("Cowardly refusing to create an empty archive")));
+       if (args.compress_autodetect && archive_names

diff --git a/app-arch/tar/tar-1.29-r3.ebuild b/app-arch/tar/tar-1.29-r3.ebuild
new file mode 100644
index 00000000..857621b
--- /dev/null
+++ b/app-arch/tar/tar-1.29-r3.ebuild
@@ -0,0 +1,81 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI="5"
+
+inherit flag-o-matic eutils
+
+DESCRIPTION="Use this to make tarballs :)"
+HOMEPAGE="https://www.gnu.org/software/tar/"
+SRC_URI="mirror://gnu/tar/${P}.tar.bz2
+	mirror://gnu-alpha/tar/${P}.tar.bz2"
+
+LICENSE="GPL-3+"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~amd64-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~hppa-hpux ~ia64-hpux ~x86-interix ~amd64-linux ~arm-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="acl elibc_glibc minimal nls selinux static userland_GNU xattr"
+
+RDEPEND="acl? ( virtual/acl )
+	selinux? ( sys-libs/libselinux )"
+DEPEND="${RDEPEND}
+	nls? ( >=sys-devel/gettext-0.10.35 )
+	xattr? ( elibc_glibc? ( sys-apps/attr ) )"
+
+PATCHES=(
+	"${FILESDIR}/${P}-extract-pathname-bypass-upstream.patch" #598334
+	"${FILESDIR}/${P}-add-files.patch"
+)
+
+src_prepare() {
+	epatch "${PATCHES[@]}"
+	epatch_user
+
+	if ! use userland_GNU ; then
+		sed -i \
+			-e 's:/backup\.sh:/gbackup.sh:' \
+			scripts/{backup,dump-remind,restore}.in \
+			|| die "sed non-GNU"
+	fi
+}
+
+src_configure() {
+	use static && append-ldflags -static
+	FORCE_UNSAFE_CONFIGURE=1 \
+	econf \
+		--enable-backup-scripts \
+		--bindir="${EPREFIX}"/bin \
+		--libexecdir="${EPREFIX}"/usr/sbin \
+		$(usex userland_GNU "" "--program-prefix=g") \
+		$(use_with acl posix-acls) \
+		$(use_enable nls) \
+		$(use_with selinux) \
+		$(use_with xattr xattrs)
+}
+
+src_install() {
+	default
+
+	local p=$(usex userland_GNU "" "g")
+	if [[ -z ${p} ]] ; then
+		# a nasty yet required piece of baggage
+		exeinto /etc
+		doexe "${FILESDIR}"/rmt
+	fi
+
+	# autoconf looks for gtar before tar (in configure scripts), hence
+	# in Prefix it is important that it is there, otherwise, a gtar from
+	# the host system (FreeBSD, Solaris, Darwin) will be found instead
+	# of the Prefix provided (GNU) tar
+	if use prefix ; then
+		dosym tar /bin/gtar
+	fi
+
+	mv "${ED}"/usr/sbin/${p}backup{,-tar} || die
+	mv "${ED}"/usr/sbin/${p}restore{,-tar} || die
+
+	if use minimal ; then
+		find "${ED}"/etc "${ED}"/*bin/ "${ED}"/usr/*bin/ \
+			-type f -a '!' '(' -name tar -o -name ${p}tar ')' \
+			-delete || die
+	fi
+}


             reply	other threads:[~2017-01-17 20:43 UTC|newest]

Thread overview: 8+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-01-17 20:43 Mike Frysinger [this message]
  -- strict thread matches above, loose matches on Subject: below --
2025-03-31  4:25 [gentoo-commits] repo/gentoo:master commit in: app-arch/tar/, app-arch/tar/files/ Sam James
2020-12-23  8:12 Fabian Groffen
2019-02-23 19:15 Lars Wendler
2019-01-11  1:34 Thomas Deutschmann
2019-01-01 14:38 Lars Wendler
2018-06-19 12:27 Thomas Deutschmann
2016-12-22 22:57 Lars Wendler

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1484685764.0be4e2ac7ec0906aff61da2a1a749ebd17db746c.vapier@gentoo \
    --to=vapier@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox